<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;
use App\Http\Base\BaseModel;

class WorkflowModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "workflow";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "workflow";

	/**
	* primary key from table remember eloquent doesnt support composite primary key
	*/
	protected $primaryKey = "id";
	/**
	* check the incrementing boolean if the incrementing from database is false then the value is false by default
	*/
	// public $incrementing = false;
	/**
	* fillable property for eloquent attribute cast
	*/
	protected $fillable=[
		"id", "tipeTransaksi", "urlTransaksi", "kapalId", "namaTransaksi", "refId", "dateUpdated", "dateCreated", "requesterId", "approverId", "status", "date_updated"
	];

	/**
	* Creating raw object from table that, this purpose for making you easier for remembering all attribute
	*/


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
    */
	protected $aliasPaging = [
		"tipeTransaksi" => "workflow.tipeTransaksi",
		"namaTransaksi" => "workflow.namaTransaksi",
		"dateCreated" => "workflow.dateCreated",
		"refId" => "workflow.refId",
		"requesterId" => "workflow.requesterId",
		"requesterName" => "requesterId.name",
        "dateStart" => "workflow.dateCreated",
        "dateEnd" => "workflow.dateCreated"
	 ];

	public function joinRelationRequesterId($alias = "requesterId")
	{
		$this->getQuery()->join("users as $alias", "$alias.id", "=", "workflow.requesterId");
		return $this;
	}
}